[ostree] config: add new parameter "commit-update-summary" to core section



commit 9e6ac6d822f4dded703a99912f629ea1e9b3bcbc
Author: Giuseppe Scrivano <gscrivan redhat com>
Date:   Thu Apr 2 12:33:07 2015 +0200

    config: add new parameter "commit-update-summary" to core section
    
    When set to true, the summary file is automatically updated after
    a commit.
    
    Signed-off-by: Giuseppe Scrivano <gscrivan redhat com>

 Makefile-tests.am              |    1 +
 doc/ostree.repo-config.xml     |    7 +++++
 src/ostree/ot-builtin-commit.c |   12 ++++++++
 tests/test-auto-summary.sh     |   55 ++++++++++++++++++++++++++++++++++++++++
 4 files changed, 75 insertions(+), 0 deletions(-)
---
diff --git a/Makefile-tests.am b/Makefile-tests.am
index 04e2676..f9c0f51 100644
--- a/Makefile-tests.am
+++ b/Makefile-tests.am
@@ -49,6 +49,7 @@ testfiles = test-basic \
        test-setuid \
        test-delta \
        test-xattrs \
+       test-auto-summary \
        $(NULL)
 insttest_SCRIPTS = $(addprefix tests/,$(testfiles:=.sh))
 
diff --git a/doc/ostree.repo-config.xml b/doc/ostree.repo-config.xml
index 26fef07..38b7a0b 100644
--- a/doc/ostree.repo-config.xml
+++ b/doc/ostree.repo-config.xml
@@ -85,6 +85,13 @@ Boston, MA 02111-1307, USA.
       </varlistentry>
 
       <varlistentry>
+        <term><varname>commit-update-summary</varname></term>
+        <listitem><para>Boolean value controlling whether or not to
+        automatically update the summary file after a commit.  Defaults
+        to <literal>false</literal>.</para></listitem>
+      </varlistentry>
+
+      <varlistentry>
         <term><varname>fsync</varname></term>
         <listitem><para>Boolean value controlling whether or not to
         ensure files are on stable storage when performing operations
diff --git a/src/ostree/ot-builtin-commit.c b/src/ostree/ot-builtin-commit.c
index db17f53..0a36ef3 100644
--- a/src/ostree/ot-builtin-commit.c
+++ b/src/ostree/ot-builtin-commit.c
@@ -487,6 +487,7 @@ ostree_builtin_commit (int argc, char **argv, GCancellable *cancellable, GError
 
   if (!skip_commit)
     {
+      gboolean update_summary;
       if (!ostree_repo_write_commit (repo, parent, opt_subject, opt_body, metadata,
                                      OSTREE_REPO_FILE (root),
                                      &commit_checksum, cancellable, error))
@@ -522,6 +523,17 @@ ostree_builtin_commit (int argc, char **argv, GCancellable *cancellable, GError
 
       if (!ostree_repo_commit_transaction (repo, &stats, cancellable, error))
         goto out;
+
+      if (!ot_keyfile_get_boolean_with_default (ostree_repo_get_config (repo), "core",
+                                                "commit-update-summary", FALSE,
+                                                &update_summary, error))
+        goto out;
+
+      if (update_summary && !ostree_repo_regenerate_summary (repo,
+                                                             NULL,
+                                                             cancellable,
+                                                             error))
+        goto out;
     }
   else
     {
diff --git a/tests/test-auto-summary.sh b/tests/test-auto-summary.sh
new file mode 100755
index 0000000..6cc4f06
--- /dev/null
+++ b/tests/test-auto-summary.sh
@@ -0,0 +1,55 @@
+#!/bin/bash
+#
+# Copyright (C) 2011 Colin Walters <walters verbum org>
+# Copyright (C) 2015 Red Hat, Inc.
+#
+# This library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2 of the License, or (at your option) any later version.
+#
+# This library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public
+# License along with this library; if not, write to the
+# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+set -e
+
+echo "1..1"
+
+. $(dirname $0)/libtest.sh
+
+setup_test_repository "bare"
+echo "ok setup"
+
+mkdir test
+
+echo hello > test/a
+
+${CMD_PREFIX} $OSTREE commit -b test -s "A commit" test
+echo "ok commit 1"
+
+${CMD_PREFIX} $OSTREE summary --update
+
+OLD_MD5=$(md5sum repo/summary)
+
+echo hello2 > test/a
+
+${CMD_PREFIX} $OSTREE commit -b test -s "Another commit" test
+echo "ok commit 2"
+
+assert_streq $OLD_MD5 $(md5sum repo/summary)
+
+${CMD_PREFIX} $OSTREE --repo=repo config set core.commit-update-summary true
+
+echo hello3 > test/a
+
+${CMD_PREFIX} $OSTREE commit -b test -s "Another commit..." test
+echo "ok commit 3"
+
+assert_not_streq $OLD_MD5 $(md5sum repo/summary)


[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]